@echo Off

REM User settable parameters:
REM ----------------------------------------
SET SQLServer=LocalHost
SET DurationSeconds=30
SET ThreadCount=8
SET OustandingIOs=8
REM ----------------------------------------

SET PATH=%PATH%;C:\Program Files (x86)\SQLIO;

echo Initializing database.
sqlcmd -S %SQLServer% -d master -i Scripts\ScriptCreateDatabase.txt
sqlcmd -S %SQLServer% -d ServerIO -i Scripts\ScriptCreateTables.txt

ECHO SET NOCOUNT ON; >Temp\TempDeleteScript.txt
ECHO DELETE FROM [RawData] WHERE ServerName = '%COMPUTERNAME%' >>Temp\TempDeleteScript.txt
ECHO GO >>Temp\TempDeleteScript.txt
ECHO DELETE FROM [ParsedData] WHERE ServerName = '%COMPUTERNAME%' >>Temp\TempDeleteScript.txt
sqlcmd -S %SQLServer% -d ServerIO -i Temp\TempDeleteScript.txt

echo Initializing workload file(s).
sqlio -kW -s10 -fsequential -t8 -o8 -b8 -FFileParameters.txt >Temp\TempScriptInsertResults.txt

echo Random writes.
for %%x in (4,8,16,32,64) do (
	echo %%xk
	echo SET NOCOUNT ON; >Temp\TempScriptInsertResults.txt
	<nul Set /P string="INSERT INTO RawData([ServerName], [Text]) SELECT '%COMPUTERNAME%', '" >>Temp\TempScriptInsertResults.txt
	sqlio -kW -t%ThreadCount% -s%DurationSeconds% -o%OustandingIOs% -frandom -b%%x -BH -LS -FFileParameters.txt >>Temp\TempScriptInsertResults.txt
	<nul Set /P string="'" >>Temp\TempScriptInsertResults.txt
	sqlcmd -S "%SQLServer%" -d ServerIO -i Temp\TempScriptInsertResults.txt
)

echo Random reads.
for %%x in (4,8,16,32,64) do (
	echo %%xk
	echo SET NOCOUNT ON; >Temp\TempScriptInsertResults.txt
	<nul Set /P string="INSERT INTO RawData([ServerName], [Text]) SELECT '%COMPUTERNAME%', '" >>Temp\TempScriptInsertResults.txt
	sqlio -kR -t%ThreadCount% -s%DurationSeconds% -o%OustandingIOs% -frandom -b%%x -BH -LS -FFileParameters.txt >>Temp\TempScriptInsertResults.txt
	<nul Set /P string="'" >>Temp\TempScriptInsertResults.txt
	sqlcmd -S "%SQLServer%" -d ServerIO -i Temp\TempScriptInsertResults.txt
)

echo Sequential writes.
for %%x in (4,8,16,32,64) do (
	echo %%xk
	echo SET NOCOUNT ON; >Temp\TempScriptInsertResults.txt
	<nul Set /P string="INSERT INTO RawData([ServerName], [Text]) SELECT '%COMPUTERNAME%', '" >>Temp\TempScriptInsertResults.txt
	sqlio -kW -t%ThreadCount% -s%DurationSeconds% -o%OustandingIOs% -fsequential -b%%x -BH -LS -FFileParameters.txt >>Temp\TempScriptInsertResults.txt
	<nul Set /P string="'" >>Temp\TempScriptInsertResults.txt
	sqlcmd -S "%SQLServer%" -d ServerIO -i Temp\TempScriptInsertResults.txt
)

echo Sequential reads.
for %%x in (4,8,16,32,64) do (
	echo %%xk
	echo SET NOCOUNT ON; >Temp\TempScriptInsertResults.txt
	<nul Set /P string="INSERT INTO RawData([ServerName], [Text]) SELECT '%COMPUTERNAME%', '" >>Temp\TempScriptInsertResults.txt
	sqlio -kR -t%ThreadCount% -s%DurationSeconds% -o%OustandingIOs% -fsequential -b%%x -BH -LS -FFileParameters.txt >>Temp\TempScriptInsertResults.txt
	<nul Set /P string="'" >>Temp\TempScriptInsertResults.txt
	sqlcmd -S "%SQLServer%" -d ServerIO -i Temp\TempScriptInsertResults.txt
)

echo Parsing data...
TYPE Scripts\ScriptParseData.txt >Temp\TempScriptParseData.txt
ECHO '%COMPUTERNAME%' >>Temp\TempScriptParseData.txt
sqlcmd -S %SQLServer% -d ServerIO -i Temp\TempScriptParseData.txt

echo Complete.
